package cz.upol.jj2.lab06;

import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
/**
 * Priklad ukazujici potrebu oddeleni vypoctu od "hlavniho vlakna aplikace" (EDT - EventDispatcherThread).
 */
public class SwingFib extends JFrame {
    private JButton btnStart;
    private JButton btnStop;
    private JTextField txtInput;
    private JLabel lblOutput;

    public SwingFib() {
        super();

        /////////// inicializace grafickeho rozhrani ///////////

        this.setTitle("Demo");
        this.setLayout(new FlowLayout());
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setSize(300, 70);

        txtInput = new JTextField("30", 5);
        lblOutput = new JLabel("Vysledek:");

        btnStart = new JButton("start");
        btnStop = new JButton("stop");
        btnStop.setEnabled(false);

        this.add(txtInput);
        this.add(lblOutput);
        this.add(btnStart);
        this.add(btnStop);

        ///////// konec inicializace grafickeho rozhrani ///////////


        // zahajeni vypoctu
        btnStart.addActionListener(e -> {
            final int arg = Integer.parseInt(txtInput.getText());    // nacte vstup
            adjustGUI(true);  //snaha o aktualizaci GUI
            System.out.println("computing" + arg);
            int x = fib(arg); // provede vypocet
            System.out.println("done");
            adjustGUI(false); //snaha o aktualizaci GUI
            displayResult(x);                                        // zobrazi vysledek
        });


        // preruseni vypoctu?
        btnStop.addActionListener(e -> {
        });        //nemame jak! (je vubec mozne tuto udalost vyvolat, kdyz vypocet bezi?)
    }

    /**
     * Upravi graficke rozhrani tak, aby signalizovalo, ze probiha vypocet
     */
    public void adjustGUI(boolean computing) {
        if (computing) {
            lblOutput.setText("Wait!");
            btnStart.setEnabled(false);
            btnStop.setEnabled(true);
        } else {
            lblOutput.setText("Ready");
            btnStart.setEnabled(true);
            btnStop.setEnabled(false);

        }
    }

    /**
     * Zobrazi vysledek vypoctu
     *
     * @param value -- vysledna hodnota
     */
    public void displayResult(int value) {
        lblOutput.setText(Integer.toString(value));
    }

    /**
     * Zobrazi, ze vypocet byl prerusen (ale nevime, jak vypocet prerusit)
     */
    public void displayCancel() {
        lblOutput.setText("Cancelled");
        btnStart.setEnabled(true);
        btnStop.setEnabled(false);
    }

    /**
     * Vypocte fibonnaciho cislo, slouzi k demonstraci narocneho vypoctu
     */
    public static int fib(int n) {
        if (n == 0) return 0;
        if (n == 1) return 1;
        return fib(n - 1) + fib(n - 2);
    }

    public static void main(String[] args) {
        JFrame frame = new SwingFib();
        frame.setVisible(true);
    }
}